macos_common.h File Reference
`#include <sched.h>`
`#include <sys/types.h>`
`#include <sys/sysctl.h>`
`#include <libkern/OSAtomic.h>`
Include dependency graph for macos_common.h:

Go to the source code of this file.

## Macros

#define | __TBB_Yield() sched_yield()
#define | __TBB_HardwareConcurrency() __TBB_macos_available_cpu()
#define | __TBB_UnknownArchitecture 1
#define | __TBB_machine_cmpswp8 __TBB_machine_cmpswp8_OsX
#define | __TBB_WORDSIZE __SIZEOF_POINTER__
#define | __TBB_ENDIANNESS __TBB_ENDIAN_UNSUPPORTED
#define | __TBB_control_consistency_helper() OSMemoryBarrier()
#define | __TBB_acquire_consistency_helper() OSMemoryBarrier()
#define | __TBB_release_consistency_helper() OSMemoryBarrier()
#define | __TBB_full_memory_fence() OSMemoryBarrier()
#define | __TBB_USE_GENERIC_PART_WORD_CAS 1
#define | __TBB_USE_GENERIC_PART_WORD_FETCH_ADD 1
#define | __TBB_USE_GENERIC_FETCH_STORE 1
#define | __TBB_USE_GENERIC_HALF_FENCED_LOAD_STORE 1
#define | __TBB_USE_GENERIC_RELAXED_LOAD_STORE 1
#define | __TBB_USE_GENERIC_SEQUENTIAL_CONSISTENCY_LOAD_STORE 1

## Functions

static int | __TBB_macos_available_cpu ()
static int64_t | __TBB_machine_cmpswp8_OsX (volatile void *ptr, int64_t value, int64_t comparand)
static int32_t | __TBB_machine_cmpswp4 (volatile void *ptr, int32_t value, int32_t comparand)
static int32_t | __TBB_machine_fetchadd4 (volatile void *ptr, int32_t addend)
static int64_t | __TBB_machine_fetchadd8 (volatile void *ptr, int64_t addend)

## Macro Definition Documentation

## __TBB_acquire_consistency_helper

#define __TBB_acquire_consistency_helper | ( |  | ) | OSMemoryBarrier()

Definition at line 92 of file macos_common.h.

## __TBB_control_consistency_helper

#define __TBB_control_consistency_helper | ( |  | ) | OSMemoryBarrier()

As this generic implementation has absolutely no information about underlying hardware, its performance most likely will be sub-optimal because of full memory fence usages where a more lightweight synchronization means (or none at all) could suffice. Thus if you use this header to enable TBB on a new platform, consider forking it and relaxing below helpers as appropriate.

Definition at line 91 of file macos_common.h.

## __TBB_ENDIANNESS

#define __TBB_ENDIANNESS __TBB_ENDIAN_UNSUPPORTED

Definition at line 83 of file macos_common.h.

## __TBB_full_memory_fence

#define __TBB_full_memory_fence | ( |  | ) | OSMemoryBarrier()

Definition at line 94 of file macos_common.h.

## __TBB_HardwareConcurrency

#define __TBB_HardwareConcurrency | ( |  | ) | __TBB_macos_available_cpu()

Definition at line 39 of file macos_common.h.

## __TBB_machine_cmpswp8

#define __TBB_machine_cmpswp8 __TBB_machine_cmpswp8_OsX

Definition at line 66 of file macos_common.h.

## __TBB_release_consistency_helper

#define __TBB_release_consistency_helper | ( |  | ) | OSMemoryBarrier()

Definition at line 93 of file macos_common.h.

## __TBB_UnknownArchitecture

#define __TBB_UnknownArchitecture 1

Definition at line 44 of file macos_common.h.

## __TBB_USE_GENERIC_FETCH_STORE

#define __TBB_USE_GENERIC_FETCH_STORE 1

Definition at line 121 of file macos_common.h.

## __TBB_USE_GENERIC_HALF_FENCED_LOAD_STORE

#define __TBB_USE_GENERIC_HALF_FENCED_LOAD_STORE 1

Definition at line 122 of file macos_common.h.

## __TBB_USE_GENERIC_PART_WORD_CAS

#define __TBB_USE_GENERIC_PART_WORD_CAS 1

Definition at line 119 of file macos_common.h.

## __TBB_USE_GENERIC_PART_WORD_FETCH_ADD

#define __TBB_USE_GENERIC_PART_WORD_FETCH_ADD 1

Definition at line 120 of file macos_common.h.

## __TBB_USE_GENERIC_RELAXED_LOAD_STORE

#define __TBB_USE_GENERIC_RELAXED_LOAD_STORE 1

Definition at line 123 of file macos_common.h.

## __TBB_USE_GENERIC_SEQUENTIAL_CONSISTENCY_LOAD_STORE

#define __TBB_USE_GENERIC_SEQUENTIAL_CONSISTENCY_LOAD_STORE 1

Definition at line 127 of file macos_common.h.

## __TBB_WORDSIZE

#define __TBB_WORDSIZE __SIZEOF_POINTER__

Definition at line 73 of file macos_common.h.

## __TBB_Yield

#define __TBB_Yield | ( |  | ) | sched_yield()

Definition at line 24 of file macos_common.h.

## Function Documentation

## __TBB_machine_cmpswp4()

static int32_t __TBB_machine_cmpswp4 | ( | volatile void * | ptr,
|  | int32_t | value,
|  | int32_t | comparand
| ) |  |

inline static

Definition at line 96 of file macos_common.h.

{
__TBB_ASSERT( tbb::internal::is_aligned(ptr,4), "address not properly aligned for macOS atomics");
int32_t* address = (int32_t*)ptr;
while( !OSAtomicCompareAndSwap32Barrier(comparand, value, address) ){
int32_t snapshot = *address;
if( snapshot!=comparand ) return snapshot;
}
return comparand;
}

References __TBB_ASSERT, address, tbb::internal::is_aligned(), and value.

Here is the call graph for this function:

## __TBB_machine_cmpswp8_OsX()

static int64_t __TBB_machine_cmpswp8_OsX | ( | volatile void * | ptr,
|  | int64_t | value,
|  | int64_t | comparand
| ) |  |

inline static

Definition at line 51 of file macos_common.h.

{
__TBB_ASSERT( tbb::internal::is_aligned(ptr,8), "address not properly aligned for macOS* atomics");
int64_t* address = (int64_t*)ptr;
while( !OSAtomicCompareAndSwap64Barrier(comparand, value, address) ){
#if __TBB_WORDSIZE==8
int64_t snapshot = *address;
#else
int64_t snapshot = OSAtomicAdd64( 0, address );
#endif
if( snapshot!=comparand ) return snapshot;
}
return comparand;
}

References __TBB_ASSERT, address, tbb::internal::is_aligned(), and value.

Here is the call graph for this function:

## __TBB_machine_fetchadd4()

static int32_t __TBB_machine_fetchadd4 | ( | volatile void * | ptr,
|  | int32_t | addend
| ) |  |

inline static

Definition at line 107 of file macos_common.h.

{
__TBB_ASSERT( tbb::internal::is_aligned(ptr,4), "address not properly aligned for macOS atomics");
return OSAtomicAdd32Barrier(addend, (int32_t*)ptr) - addend;
}

References __TBB_ASSERT, and tbb::internal::is_aligned().

Here is the call graph for this function:

## __TBB_machine_fetchadd8()

static int64_t __TBB_machine_fetchadd8 | ( | volatile void * | ptr,
|  | int64_t | addend
| ) |  |

inline static

Definition at line 113 of file macos_common.h.

{
__TBB_ASSERT( tbb::internal::is_aligned(ptr,8), "address not properly aligned for macOS atomics");
return OSAtomicAdd64Barrier(addend, (int64_t*)ptr) - addend;
}

References __TBB_ASSERT, and tbb::internal::is_aligned().

Here is the call graph for this function:

## __TBB_macos_available_cpu()

static int __TBB_macos_available_cpu | ( |  | ) |

inline static

Definition at line 31 of file macos_common.h.

{
int name[2] = {CTL_HW, HW_AVAILCPU};
int ncpu;
size_t size = sizeof(ncpu);
sysctl( name, 2, &ncpu, &size, NULL, 0 );
return ncpu;
}

References name, and size.

__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
size
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t size
Definition: ittnotify_static.h:109
address
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void * address
Definition: ittnotify_static.h:109
tbb::internal::is_aligned
bool is_aligned(T *pointer, uintptr_t alignment)
A function to check if passed in pointer is aligned on a specific border.
Definition: tbb_stddef.h:370
value
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void ITT_FORMAT p void ITT_FORMAT p void size_t ITT_FORMAT d void ITT_FORMAT p const wchar_t ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s no args void ITT_FORMAT p size_t ITT_FORMAT d no args const wchar_t const wchar_t ITT_FORMAT s __itt_heap_function void size_t int ITT_FORMAT d __itt_heap_function void ITT_FORMAT p __itt_heap_function void void size_t int ITT_FORMAT d no args no args unsigned int ITT_FORMAT u const __itt_domain __itt_id ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain __itt_id ITT_FORMAT p const __itt_domain __itt_id __itt_timestamp __itt_timestamp ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain ITT_FORMAT p const __itt_domain __itt_string_handle unsigned long long value
Definition: ittnotify_static.h:192
name
void const char const char int ITT_FORMAT __itt_group_sync x void const char * name
Definition: ittnotify_static.h:93

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.